'Besonderheiten fuer den Editor
declare function editor_frage(frage as string) as byte
declare sub editor_leseopt(byval x as ubyte, byval y as ubyte)
declare sub editor_meldung(text as string)
declare sub editor_setzeopt(byval x as ubyte, byval y as ubyte, byval wert as byte)
declare sub editor_setoptionen(byval set as string)
declare sub testspiel

const EDITOR_STEINBREITE = 20, EDITOR_LEVELBREITE = 32
const EDITOR_STEINHOEHE  = 20, EDITOR_LEVELHOEHE  = 20
const EDITOR_LVLBPLUS = 0, EDITOR_LVLHPLUS = 4
const EDITOR_LEVELPFAD = "level/", EDITOR_EBENEN = 1
const EDITOR_ZEITMIN = 20, EDITOR_ZEITMAX = 995, EDITOR_ZEITSTEP = 5
const EDITOR_WINTITEL = "Laser-Editor"
dim shared as ushort editorfeld(0 to 33, 0 to 25, 0)
for i as ubyte = 1 to 6
  editorfeld(i, 1, 0) = i-1
next
for i as ubyte = 1 to 32
  editorfeld(i, 2, 0) = i+10
next

#include "editor003.inc"

function editor_frage(frage as string) as byte
  dim antwort as string, speicher as any ptr = bildschirm_speichern
  _MODUS_ -= 10
  meldung frage
  _MODUS_ += 10
  do
    antwort = lcase(inkey)
    sleep 1
  loop until antwort = "j" or antwort = "y" or antwort = "n" or antwort = chr(27)
  bildschirm_zuruecksetzen(speicher)
  if antwort = "n" or antwort = chr(27) then return 0 else return -1
end function

sub editor_leseopt(byval x as ubyte, byval y as ubyte)
  ' gibt den aktuellen Optionswert auf dem Bildschirm aus
  color &hffffff
  locate 1, 66
  print "Drehung: " & (editorfeld(x, y, 0) shr 8) & "   "
end sub

sub editor_meldung(text as string)
  dim taste as string, speicher as any ptr = bildschirm_speichern
  _MODUS_ -= 10
  meldung text
  _MODUS_ += 10
  do : sleep 1 : loop until inkey = " "
  bildschirm_zuruecksetzen(speicher)
end sub

sub editor_setzeopt(byval x as ubyte, byval y as ubyte, byval wert as byte)
  ' setzt den Optionswert hoeher (wert=1) oder tiefer (wert=-1)
  if spiegel(editorfeld(x, y, 0) and 255).naechster = editorfeld(x, y, 0) and 255 _
     and spiegel(editorfeld(x, y, 0) and 255).dreh <> 3 then exit sub
  dim aktuell as ubyte
  aktuell = editorfeld(x, y, 0) shr 8
  if wert = 1 and aktuell < 99 then editorfeld(x, y, 0) = (editorfeld(x, y, 0) and 255) + (aktuell+1)*256
  if wert = -1 and aktuell > 0 then editorfeld(x, y, 0) = (editorfeld(x, y, 0) and 255) + (aktuell-1)*256
  editor_leseopt(x, y)
  stein x, y, editorfeld(x, y, 0)
end sub

sub editor_setoptionen(byval set as string)
  dim speicher as any ptr, typ as ubyte, version as ushort
  dim as string kommentar, autor, eingabe, major, minor
  speicher = bildschirm_speichern
  cls
  ladeinfo(set, typ, kommentar, autor, version)
  major = str(version\1000)
  minor = str(version mod 1000)
  locate 1, 1
  typ = 1
  print "Einstellungen fuer das Set " & set
  eingabe = inputt(3, 1, "Autor: ", string(63, 42), autor)
  if eingabe = chr(255) + "k" then exit sub
  if eingabe <> chr(27) then autor = eingabe
  eingabe = inputt(4, 1, "Majorrelease: ", "00", major)
  if eingabe = chr(255) + "k" then exit sub
  if eingabe = chr(27) and val(eingabe) < 64 then
    version = val(major)*1000
  else
    version = val(eingabe)*1000
  end if
  eingabe = inputt(5, 1, "Minorrelease: ", "000", minor)
  if eingabe = chr(255) + "k" then exit sub
  if eingabe = chr(27) then
    version += val(minor)
  else
    version += val(eingabe)
  end if
  locate 6, 1
  print "bisheriger Kommentar:"
  print kommentar
  print
  print "neuer Kommentar (max. 255 Zeichen; eine leere Eingabe uebernimmt den alten Kommentar):"
  input "", eingabe
  if eingabe <> "" then kommentar = left(eingabe, 255)
  speichereinfo(set, typ, kommentar, autor, version)
  cls
  bildschirm_zuruecksetzen(speicher)
end sub

sub testspiel
  dim speicher as any ptr, ergebnis as TypSpielergebnis
  _MODUS_ = 10
  punkte = 0
  speicher = bildschirm_speichern
  speichern "temp", 0
  ergebnis = spiel("temp", 0)
  cls
  bildschirm_zuruecksetzen speicher
  laden "temp", 0
  kill "level/temp"
  for i as ubyte = 1 to 32
    feld(i, 1) = editorfeld(i, 1, 0)
    feld(i, 2) = editorfeld(i, 2, 0)
  next
  _MODUS_ = 1
  color &hffffff
end sub
